__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a8"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2004/11/09 15:15:52 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rPrefs.py,v 1.3 2004/11/09 15:15:52 asc Exp $

import wx
from rConstants  import *
from rEdit       import rEdit

ID_PREFS_PREFSBOX     = wx.NewId()
ID_PREFS_SERVICELIST  = wx.NewId()
ID_PREFS_ADDBUTTON    = wx.NewId()
ID_PREFS_EDITBUTTON   = wx.NewId()
ID_PREFS_REMOVEBUTTON = wx.NewId()
ID_PREFS_IMPORTBUTTON = wx.NewId()
ID_PREFS_CLOSEBUTTON  = wx.NewId()

class rPrefs (wx.Frame) :

    def __init__ (self,parent,style,cfg):
        wx.Frame.__init__(self,parent,style,TITLE_SERVICES)

        self.__cfg__      = cfg    
        self.__selected__ = None

        self.__controls__ = {"current":0};
        self.__ctrlkeys__ = [];

	self.__redit__ = 0

        # can I pass a 'sizer' rather than
        # hard-code the dimensions? - no

	# compute the height/width based on
	# the length of the text a la MP
	# status bar hack - what happens when
	# new stuff is added?

	# not an ideal solution...

	services = wx.ListCtrl(self, ID_PREFS_SERVICELIST,
			       (0,0), (150,75),
			       wx.LC_SINGLE_SEL,
			       )

	# services.InsertColumn(0, "foobar",wx.LIST_FORMAT_LEFT,  width=-1)

        self.__addcontrol(services)

        self.__addcontrol(wx.Button(self,ID_PREFS_ADDBUTTON,
                                   BUTTON_ADD))

        self.__addcontrol(wx.Button(self,ID_PREFS_EDITBUTTON,
                                   BUTTON_EDIT))
        
        self.__addcontrol(wx.Button(self,ID_PREFS_REMOVEBUTTON,
                                   BUTTON_REMOVE))
        
        self.__addcontrol(wx.Button(self,ID_PREFS_CLOSEBUTTON,
                                   BUTTON_CLOSE))

        #
        
        self.LoadServices()
        
        self.__controls__[ID_PREFS_EDITBUTTON].Enable(False)
        self.__controls__[ID_PREFS_REMOVEBUTTON].Enable(False)
        
        #

        spacer = wx.Size(5,5)
        
	sz_services = wx.BoxSizer(wx.HORIZONTAL)
        sz_buttons  = wx.BoxSizer(wx.VERTICAL)
        
        sz_buttons.Add(self.__controls__[ID_PREFS_ADDBUTTON])
        sz_buttons.Add(self.__controls__[ID_PREFS_EDITBUTTON])
        sz_buttons.Add(self.__controls__[ID_PREFS_REMOVEBUTTON])
        
        sz_close = wx.BoxSizer(wx.HORIZONTAL)
        sz_close.Add(self.__controls__[ID_PREFS_CLOSEBUTTON])
        
        sz_services.Add(self.__controls__[ID_PREFS_SERVICELIST],1,wx.EXPAND)
        sz_services.Add(spacer)
        sz_services.Add(sz_buttons)
 
        sz_body = wx.BoxSizer(wx.VERTICAL)

        sz_body.Add(sz_services)
        sz_body.Add(spacer)        
        sz_body.Add(wx.StaticLine(self,-1),0,wx.EXPAND)
        sz_body.Add(spacer)
        sz_body.Add(spacer)
        sz_body.Add(sz_close,0,wx.ALIGN_RIGHT)

	sz_padx = wx.BoxSizer(wx.HORIZONTAL)
	sz_padx.Add(spacer)
	sz_padx.Add(sz_body)
	sz_padx.Add(spacer)

	sz_main = wx.BoxSizer(wx.VERTICAL)
	sz_main.Add(spacer)
	sz_main.Add(sz_padx)
	sz_main.Add(spacer)
	
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)

        self.CreateStatusBar()
        sz_main.Fit(self)

        #
        
        wx.EVT_BUTTON(self, ID_PREFS_ADDBUTTON,    self.Add)
        wx.EVT_BUTTON(self, ID_PREFS_EDITBUTTON,   self.Edit)
        wx.EVT_BUTTON(self, ID_PREFS_REMOVEBUTTON, self.Remove)
        wx.EVT_BUTTON(self, ID_PREFS_CLOSEBUTTON,  self.Close)

	wx.EVT_KEY_DOWN(self,self.KeyDown)

	# I'm not sure why this is necessary - to make
        # matters worse, keyboard events appear to be
        # locked by the control key in ListCtrl - that
        # no other key events are captured  until the
        # user lets go of the control key. I don't know
        # whether tis is a short-coming in wxPython or
        # me
        
	wx.EVT_LIST_KEY_DOWN(self,ID_PREFS_SERVICELIST, self.ListKeyDown)

        wx.EVT_LIST_ITEM_SELECTED(self, ID_PREFS_SERVICELIST, self.EvtListCtrl)
        wx.EVT_LIST_ITEM_ACTIVATED(self, ID_PREFS_SERVICELIST, self.EvtListCtrlDClick)

	# this is just to save typing...

	list = self.__controls__[ID_PREFS_SERVICELIST]


	if list.GetItemCount() > 0 :

           list.SetFocus()            
	   list.SetItemState(0,
		             wx.LIST_STATE_SELECTED,
			     wx.LIST_STATE_SELECTED)

        else :

            cur = self.__ctrlkeys__.index(ID_PREFS_ADDBUTTON)
            self.__controls__["current"] = cur
            
            add = self.__controls__[ID_PREFS_ADDBUTTON]
            add.SetFocus()


    #
    
    def ListKeyDown(self,event) :

        keycode = event.GetKeyCode()
	keyname = ""

        if keycode <= 256:
           keyname = chr(keycode).upper()

        if keyname == KEY_PREFS_EDIT :
            self.Edit(event)
        elif keyname == KEY_PREFS_REMOVE :
            self.Remove(event)
        else:
            pass
    
    def KeyDown(self,event):

        keycode = event.GetKeyCode()

        if keycode == WXK_TAB :

            cur   = self.__controls__["current"]
            count = len(self.__ctrlkeys__) - 1

            # note that we are accounting
            # for controls that may be disabled
            
            ctrl = None

            while ctrl == None:
                if event.ShiftDown() :
                    if cur == 0 :
                        cur = count
                    else :
                        cur = cur - 1
                else :
                    if cur >= count :
                        cur = 0
                    else :
                        cur = cur + 1
            
                id  = self.__ctrlkeys__[ cur ]

                # don't bother stopping on the
                # list control if there are no
                # services to list

                if id == ID_PREFS_SERVICELIST:
                    if self.__controls__[ id].GetItemCount() <= 0:
                        continue
                
                #
                
                if self.__controls__[ id].IsEnabled() :
                    self.__controls__["current"] = cur     
                    ctrl = self.__controls__[ id ]

            ctrl.SetFocus()

        elif keycode == WXK_RETURN :

            cur = self.__controls__["current"]
            id  = self.__ctrlkeys__[ cur ]
            
            if id == ID_PREFS_ADDBUTTON:
                self.Add(event)
            elif id == ID_PREFS_EDITBUTTON:
                self.Edit(event)
            elif id == ID_PREFS_REMOVEBUTTON:
                self.Remove(event)
            elif id == ID_PREFS_CLOSEBUTTON:
                self.Close(event)                
            else:
                pass
            
        elif event.CmdDown():

            if keycode <= 256:
                keyname = chr(keycode)
        
            if keyname == KEY_PREFS_ADD :
                self.Add(event)
            elif keyname == KEY_PREFS_CLOSE :
                self.Close(event)
            elif keyname == KEY_PREFS_EDIT :
                self.Edit(event)
            elif keyname == KEY_PREFS_REMOVE :
                self.Remove(event)
            else:
                pass
            
	else:
            pass


    #
    
    def EvtListCtrl (self,event):
        self.__controls__[ID_PREFS_EDITBUTTON].Enable(True)
        self.__controls__[ID_PREFS_REMOVEBUTTON].Enable(True)
        self.__selected__ = event.m_itemIndex

    #
    
    def EvtListCtrlDClick (self,event):
        self.__selected__ = event.m_itemIndex
        self.Edit(event)

    #
    
    def LoadServices (self) :

        self.__cfg__.Load()

	self.__controls__[ID_PREFS_SERVICELIST].ClearAll()

        self.__titles__    = []
        self.__endpoints__ = []

        i = 0

        # sort me!
        
        for s in self.__cfg__.ListServices():

            endpoint = self.__cfg__.DescribeService(s).Endpoint()
            title    = self.__cfg__.DescribeService(s).Title() or endpoint

            self.__titles__.append(title)            
            self.__endpoints__.append(endpoint)

            self.__controls__[ID_PREFS_SERVICELIST].InsertStringItem(i,title)
            i = i + 1

    #

    def Add (self,event):

	self.DisableControls()

	(x,y) = self.GetPosition()
        
        edit = rEdit(self,-1,self.__cfg__)
	edit.SetPosition((x - 25,y + 50))
        edit.Show()

    #
    
    def Edit (self,event):

        if self.__selected__ == None :
            return

	self.DisableControls()

        endpoint = self.__endpoints__[ self.__selected__ ]
        
        edit = rEdit(self,-1,self.__cfg__,endpoint)
        edit.Show()

    #
    
    def Remove (self,event):

        if self.__selected__ == None :
            return

        endpoint = self.__endpoints__[ self.__selected__ ]
        self.__cfg__.RemoveService(endpoint)

        self.LoadServices()

        #

        if len(self.__endpoints__) == 0:
            return

        #
        
	if self.__selected__ == 0 :
	   self.__selected__ = len(self.__endpoints__) - 1
	else :
	   self.__selected__ = self.__selected__ - 1

        self.SelectCurrentEndpoint()

    #
    
    def Close (self,event):
        self.Destroy()

    # this is here mostly so that
    # self.__selected__ can be gotten
    # at by rEdit.py when adding new
    # services
    
    def Selected (self,which=None) :

        # god help me - is this
        # the only way?!

        test = str(type(which))
        
        if test == "<type 'int'>" :
	   self.__selected__ = which
        elif test == "<type 'str'>" :
            self.__selected__ = self.__endpoints__.index(which)
        else:
            pass
        
	return self.__selected__

    #

    def DisableControls (self) :
        self.__controls__[ID_PREFS_ADDBUTTON].Enable(False)
        self.__controls__[ID_PREFS_EDITBUTTON].Enable(False)
        self.__controls__[ID_PREFS_REMOVEBUTTON].Enable(False)

    #

    def EnableControls (self) :
        self.__controls__[ID_PREFS_ADDBUTTON].Enable(True)
        self.__controls__[ID_PREFS_EDITBUTTON].Enable(True)
        self.__controls__[ID_PREFS_REMOVEBUTTON].Enable(True)

	#

	cur = self.__ctrlkeys__[self.__controls__["current"]]
	self.__controls__[cur].SetFocus()

	#

        self.SelectCurrentEndpoint()

    def SelectCurrentEndpoint (self) :

	list = self.__controls__[ID_PREFS_SERVICELIST]

        if list.GetItemCount <= 0 :
            return

	# print "sel %s (%s)" % (self.__selected__,self.__titles__)
	
	if self.__selected__ == None :
	    return False

        sel = self.__titles__[self.__selected__]
        
        list.SetItemState(list.FindItem(-1,sel),
                          wx.LIST_STATE_SELECTED,
                          wx.LIST_STATE_SELECTED)
    
    #
    
    def __addcontrol (self,ctrl) :
        id = ctrl.GetId()
        
	# print "add %s (%s)" % (ctrl,id)

        self.__controls__[ id ] = ctrl
        self.__ctrlkeys__.append(id)
